//+------------------------------------------------------------------+
//|                                             Lyapunov_jytv20.mq4  |
//|                                       by jaguar1637 @ yahoo.com  |
//|          from an idea of John Last, add-on Jurik Filter w/ JJMA  |            | 
//|In general, Market is chaotic when Lyapunov's indice is positive  |
//|         the market is predictable, when indice negative                |
//+------------------------------------------------------------------+ 
//| "Nobody can be exactly like me, even I have trouble doing it" 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, jaguar1637 @ yahoo.com"
#property link      "nope"

//----
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Crimson

#property indicator_width1 1

#define LOG_2_0 0.69314718055994530941723212145818
#define X       0.00001

//---- input parameters
extern int LyapunovPeriod = 1250;
extern bool JurikMode      = false; // true is better w/ Jurik mode usage
double MUL                 =  100;  // 100 for EURUSD  1 for JPY 

//---- buffers
double LyapunovBuffer[];
double LyapunovLine[];
double Det[];
double Value1, Value2;
string signal,short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(1);
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0, LyapunovBuffer);
 
//---- indicator lines
   SetIndexEmptyValue(0,0.0);
   
//---- name for DataWindow
   SetIndexDrawBegin(0,LyapunovPeriod);   

   SetIndexLabel(0,"LyapunovLine");
//-----------------

ArrayResize(LyapunovLine,LyapunovPeriod);

//----
   if ( (Symbol() == "USDJPY") || (Symbol() == "GBPJPY") || (Symbol() == "CHFJPY") || 
          (Symbol() == "AUDJPY") || (Symbol() == "NZDJPY") || (Symbol() == "EURJPY")) 
            MUL=1.0;
         else
             MUL = 100.0;
             
  signal = "  Market";
  
   return(0);
  }
//+------------------------------------------------------------------+
//| Lyapunov Chaotic to Predictable market                                         |
//+------------------------------------------------------------------+
int start()
  {
   int    ii, k,l,m, counted_bars = IndicatorCounted(); 
   
   double a = 0.00000;
   double b = 0.00000;
   double c = 0.00000;
   double d = 0.00000;
   double a1 = 0.00000;
   double b1 = 0.00000;
   double c1 = 0.00000;
   double d1 = 0.00000; 
   
            
   if(LyapunovPeriod <= 1)
       return(0);
   if(Bars <= LyapunovPeriod) 
       return(0);
//---- initial zero
  if(counted_bars < 1)
    {
      for(ii = 1; ii <= LyapunovPeriod; ii++) 
         {
           LyapunovLine[Bars-ii] = 0.0;
           LyapunovBuffer[Bars-ii] = 0.0;
         }                              
     }
  int limit = Bars - counted_bars;
   if(counted_bars > 0) 
       limit++;
//---- moving average
   for(ii = 0; ii < limit; ii++)
   {      
 
     if (JurikMode == true ) {
       
      b = MUL*iCustom(NULL,0,"JJMA",5,100,0,1,0,ii); 
      c = MUL*iCustom(NULL,0,"JJMA",5,100,0,0,0,ii); 
      a = MUL*iCustom(NULL,0,"JJMA",5,100,0,2,0,ii); 
      d = MUL*iCustom(NULL,0,"JJMA",5,100,0,3,0,ii); 
      
      b1 = MUL*iCustom(NULL,0,"JJMA",5,100,0,1,0,ii+1); 
      c1 = MUL*iCustom(NULL,0,"JJMA",5,100,0,0,0,ii+1); 
      a1 = MUL*iCustom(NULL,0,"JJMA",5,100,0,2,0,ii+1); 
      d1 = MUL*iCustom(NULL,0,"JJMA",5,100,0,3,0,ii+1);
 
      }
    else
     {
      // This comes from my mathematical research 
            
            a = High[ii];  // A
            b = Open[ii];  // B        
            c = Close[ii]; // C
            d = Low[ii];   // D
            a1 = High[ii+1];  // A
            b1 = Open[ii+1];  // B        
            c1 = Close[ii+1]; // C
            d1 = Low[ii+1];   // D 
           
     } // END JURIK MODE
       
      Value2 = MUL*((a1*d1)-(c1*b1));
      Value1 = MUL*((a*d)- (c*b));
      Det[ii] = MUL*Value1;
      if    ((Value2 > X ) && (Value1 > X)) 
             LyapunovLine[ii]= LOG_2_0 *(MathAbs( (Value2)/(Value1 ) ) );
      if (((Value2 > X) && (Value1 < -X)) || ((Value2 < -X) && (Value1 < -X)) )
             LyapunovLine[ii]= -LOG_2_0 *(MathAbs( (Value2)/(Value1) ) );
      if ((Value2 < X) && (Value1 > X)) 
             LyapunovLine[ii]= -LOG_2_0 *(MathAbs( (Value2)/(Value1) ) );
             
       if    ( (Value1 == 0.0 ) || (Value2 == 0) )
            {
             LyapunovLine[ii] = 0.0;
             LyapunovLine[ii+1] = 0.0;      
            }              

  if ( ii == 0) 
  {
//---- Curent conditions to figure out if th market is chaotic or not, tick by tick
      if (  ( (LyapunovLine[0] > X) && (LyapunovLine[1] == 0.0) && (LyapunovLine[2]< -X) ) 
         ||
          ( (LyapunovLine[0] == 0.0) && (LyapunovLine[1]> X) && 
         ((LyapunovLine[2] < -LyapunovLine[1])|| (LyapunovLine[2]< -X)  ) ) 
         ||
         ( (LyapunovLine[0] == 0.0) && (LyapunovLine[1]< -X ) && 
         ((LyapunovLine[2] > -LyapunovLine[1])|| (LyapunovLine[2]> X)  ) ) 
         )           
         { 
         signal = " : Market is Chaotic ";
         if (LyapunovLine[0] <0 )
                LyapunovBuffer[0] = -LyapunovLine[0];
            else
               LyapunovBuffer[0] = LyapunovLine[0];
         }
      else
          { 
          if ( (LyapunovLine[0] > 0 ) )
            { 
            signal = " : Market is chaotic ";
            LyapunovBuffer[0] = LyapunovLine[0]; 
            }
           else
            { 
            signal = " : Market is Predictable ";
            LyapunovBuffer[0] = LyapunovLine[0];
            }
          }
      
   short_name="Lyapunov" + signal;

   IndicatorShortName(short_name);
 
 }
 else
 {
  LyapunovBuffer[ii] = LyapunovLine[ii];
  
  }
  
  }  
//----
   return(0);
  }
//+------------------------------------------------------------------+

